/////////////////////////////////////////////////////////////////////////////
//				Remote Contorol host
//                                           Copyright(C) 2003 K-K

#define _WIN32_WINNT 0x0500
#include <windows.h>
#include <process.h>
#include <winsock.h>
#include "resource.h"
#include "image.h"
#include "remote.h"
#include "md5.h"

#define ICONMSG (WM_APP + 100)
NOTIFYICONDATA ticon;
HICON hIcon1;
HICON hIcon2;

char inifile[MAX_PATH];
HINSTANCE hInst;
int bmpdepth;
char* compbuf;

CHost host;

void GetModuleDir(unsigned char* exedir);
LRESULT CALLBACK HostDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int CmdShow)
{
	compbuf= new char[BLOCKSIZE*BLOCKSIZE*2+64];
	hInst=hInstance;
	GetModuleDir((unsigned char*)inifile);
	strcat(inifile,"\\remote.ini");

	GetPrivateProfileString("host","passwd","?",host.sPasswd,64,inifile);
	host.port=GetPrivateProfileInt("host","port",DEFAULT_PORT,inifile);
	host.crypt=GetPrivateProfileInt("host","crypt",1,inifile);
	if(GetPrivateProfileInt("host","hide",0,inifile)){
		// }EX|C^vɂȂ̂hH
		MSG msg;
		int i;
		for (i=0;i<100;i++) {
			while(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
				PeekMessage(&msg,NULL,0,0,PM_REMOVE);
			}
		}
		host.Main();
	}else{
		CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)HostDlgProc);
		MSG msg;
		while (GetMessage(&msg, NULL, NULL, NULL)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			if (msg.message==WM_CLOSE ){
				DestroyWindow(msg.hwnd);
				break;
			}
		}

//		DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)HostDlgProc);
	}
	delete [] compbuf;
	return 0;
}

//  _CAO
LRESULT CALLBACK HostDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static HMENU hPopupMenu;
	static UINT s_uTaskbarRestart;
	switch(message)
	{
		case WM_INITDIALOG:
			{
				// |bvAbvj[
				hPopupMenu = CreatePopupMenu();
				AppendMenu(hPopupMenu, MF_BYCOMMAND | MF_STRING, 0x2001, TEXT("ݒ(&C)"));
				AppendMenu(hPopupMenu, MF_BYCOMMAND | MF_STRING, IDC_CLOSE, TEXT("ؒf(&D)"));
				AppendMenu(hPopupMenu, MF_BYCOMMAND | MF_STRING, IDC_END, TEXT("I(&X)"));
				// gCACR
				hIcon1=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
				hIcon2=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON2));
				s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
				ticon.cbSize=sizeof(NOTIFYICONDATA);
				ticon.hIcon=hIcon1;
				ticon.hWnd=hWnd;
				ticon.uCallbackMessage=ICONMSG;
				ticon.uFlags= NIF_ICON | NIF_MESSAGE | NIF_TIP;
				ticon.uID=0;
				strcpy(ticon.szTip,"Remote control host");
				Shell_NotifyIcon(NIM_ADD,&ticon);
				host.Start(hWnd);
				SetDlgItemInt(hWnd,IDC_PORT ,host.port,FALSE);
				SetDlgItemText(hWnd,IDC_PASS ,host.sPasswd);
				CheckDlgButton(hWnd,IDC_CRYPT,host.crypt?BST_CHECKED:BST_UNCHECKED);
				SetTimer(hWnd, 1024, 100, NULL);
			}
			break;
		case WM_TIMER:
			KillTimer(hWnd, 1024);
			ShowWindow(hWnd,SW_HIDE);
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					{
						char d[16];
						host.port=GetDlgItemInt(hWnd,IDC_PORT,NULL,FALSE);
						wsprintf(d,"%d",host.port);
						GetDlgItemText(hWnd,IDC_PASS ,host.sPasswd,128);
						host.crypt = IsDlgButtonChecked(hWnd,IDC_CRYPT)==BST_CHECKED;
						WritePrivateProfileString("host","passwd",host.sPasswd,inifile);
						WritePrivateProfileString("host","port",d,inifile);
						WritePrivateProfileString("host","crypt",host.crypt?"1":"0",inifile);
					}
				case IDCANCEL:
					SetDlgItemInt(hWnd,IDC_PORT ,host.port,FALSE);
					SetDlgItemText(hWnd,IDC_PASS ,host.sPasswd);
					ShowWindow(hWnd,SW_HIDE);
					break;
				case IDC_CLOSE:
					host.Close();
					break;
				case IDC_END:
			//		EndDialog(hWnd, 0);
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				case 0x2001:
					ShowWindow(hWnd,SW_SHOW);
					break;
			}
			break;
		case ICONMSG:
			switch(lParam)
			{
				case WM_LBUTTONUP:
					ShowWindow(hWnd,SW_SHOW);
					break;
				case WM_RBUTTONUP:
					{
						POINT pt;
						GetCursorPos(&pt);
						SetForegroundWindow(hWnd);
						TrackPopupMenu(hPopupMenu, TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
					}
					break;
			}
			break;
		case WM_DESTROY:
			host.Stop();
			Shell_NotifyIcon(NIM_DELETE,&ticon);
			DestroyMenu(hPopupMenu);
			return 0;
		default:
			if(message == s_uTaskbarRestart){
				Shell_NotifyIcon(NIM_ADD,&ticon);
			}

			return FALSE;
	}
	return TRUE;
}

void GetModuleDir(unsigned char* exedir)
{
	unsigned int i,p=0;
	unsigned int l=GetModuleFileName(NULL,(char*)exedir,320);
	for(i=0;i<l;i++){
		//QoCgpc
		if ((0x81<=exedir[i] && exedir[i]<=0x9f)
			|| (0xe0<=exedir[i] && exedir[i]<=0xec))
		{
			i++;
		}else{
			if (exedir[i]=='\\') p=i;
		}
	}
	if (p)exedir[p+(p==3)]=0;
}


//////////////////////////////////////////////////////////////////////////
CHost::CHost()
{
	port=DEFAULT_PORT;
	hWnd=NULL;
//	soc=0;
	fauth=0;
}
CHost::~CHost()
{
}

int CHost::Start(HWND win)
{
	hWnd=win;
	_beginthread(ThreadStart, 0, this);
	return 0;
}

int CHost::Stop()
{
	hostctl=1;
	while(hostflag){
		Sleep(10);
	}
	return 0;
}
int CHost::Close()
{
	hostctl=2;
	return 0;
}

void CHost::ThreadStart(void *h)
{
	((CHost*)h)->Main();
}


void CHost::Main()
{
	hostflag=1;
	srand(GetTickCount());
	InitDisp();

//	WSADATA WSAData;
//	WSAStartup(0x0202,&WSAData);

	DWORD hSocket;  // zXg

	// sockaddr_in \
	struct sockaddr_in hAddr;
	struct sockaddr_in cAddr;
	int cAddrSize = sizeof(cAddr);

	// \Pbg
	hSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(hSocket == INVALID_SOCKET){ // failed
		WSACleanup();
		hostflag=0;
		return;
	}

	// oCh
	//memset(&hAddr, 0, sizeof(hAddr));
	hAddr.sin_port = htons(port);
	hAddr.sin_family = AF_INET;
	hAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	bind(hSocket, (struct sockaddr *) &hAddr, sizeof(hAddr));
start:
	// ڑ҂
	listen(hSocket, 1);

	fd_set fdsetread;
	int status,f;
	while(1){
		timeval timout={0,10000};
		FD_ZERO(&fdsetread);
		FD_SET( hSocket,&fdsetread);
		status=select(0,&fdsetread,NULL,NULL,&timout);
		if(hostctl==2){
			hostctl=0;
			goto start;
		}else if(hostctl){
			WSACleanup();
			hostflag=0;
			return;
		}
		if(status<0){
			WSACleanup();
			hostflag=0;
			return;
		}
		if(status)break;
	}

	int port;
	char host[128];
	soc.setPasswd(NULL,0);
	soc.accept(hSocket,host,&port);

	if(hWnd){
		wsprintf( ticon.szTip,"ڑ %s:%d",host,port );
		ticon.hIcon=hIcon2;
		Shell_NotifyIcon(NIM_MODIFY,&ticon);
	}

	int tim,t;

	fauth=0;
	mode=0;

/*
	authkey=rand();
	int dat[3]={0x901,4,authkey};
	soc.send(dat,12);
*/
	int i;
	for (i=0;i<16;i++) {
		authkey2[i]=rand();
	}
	int dat[2]={0x903,16};
	soc.send(dat,8);
	soc.send(authkey2,16);

	ResetDisp();
	while(1){
		tim=GetTickCount();
		if(mode>=2 && fauth){
			if(ChkDisp(32)<0) break;
		}
		while((status=CmdRecv())>0);
		if(status<0) break;
		t=16-(GetTickCount()-tim);
		if(t>0)
			Sleep(t);
		else
			Sleep(1);
		if(hostctl){
			break;
		}
	}
	soc.close();
	f=hostctl;
	hostctl=0;

	if(hWnd){
		wsprintf( ticon.szTip,"ؒf %s:%d",host,port);
		ticon.hIcon=hIcon1;
		Shell_NotifyIcon(NIM_MODIFY,&ticon);
	}

	if(f!=1)
		goto start;

//	WSACleanup();
	hostflag=0;
}

void CHost::MakeKey(unsigned char *dat,unsigned char *passwd,int key)
{
	unsigned char *p=passwd;
	while(p[0]){
		key=key+key*p[0];
		p++;
	}
	srand(key);
	p=passwd;
	int i=0;
	memset(dat,0,16);
	while(p[i]){
		dat[i&15]=dat[i&15]+(rand()&255)+p[i];
		i++;
	}
}

int CHost::CmdRecv()
{
	int status=soc.check();
	long dat[2];
	if(status==SOCKET_ERROR){
		// G[
		return -1;
	}else if(status==0){
		// f[^
		return 0;
	}
	if(soc.recv(dat,8)!=8){
		return -1;
	}

	// F؁[hύX
	if(dat[0]==0x902){
		if(dat[1]!=16)
			return -1;
		unsigned char cpw1[32];
		unsigned char cpw2[32];
		soc.recv(cpw1,dat[1]);
		host.MakeKey(cpw2,(unsigned char*)sPasswd,authkey);
		if(memcmp(cpw1,cpw2,16)==0){
			dat[0]=0x202;
			dat[1]=sizeof(HOSTINFO);
			info.stat=0;
			soc.send(dat,8);
			soc.send(&info,sizeof(HOSTINFO));
			fauth=1;
			return 1;
		}else{
			HOSTINFO errinfo={0,0,0,0,0,0};
			dat[0]=0x202;
			dat[1]=sizeof(HOSTINFO);
			errinfo.stat=1;
			soc.send(dat,8);
			soc.send(&errinfo,sizeof(HOSTINFO));
			return -1;
		}
	} else if(dat[0]==0x904){
		if(dat[1]!=16)
			return -1;
		unsigned char cpw[32];
		unsigned char cpw1[32];
		soc.recv(cpw1,dat[1]);
		MD5 md5;
		md5.init();
		md5.update((unsigned char*)authkey2,16);
		md5.update((unsigned char*)sPasswd,strlen(sPasswd));
		md5.final((unsigned char*)cpw);

		if(memcmp(cpw,cpw1,16)==0){
			dat[0]=0x904;
			dat[1]=1;
			dat[2]=crypt&1;
			soc.send(dat,12);

			if (crypt) {
				int i;
				for (i=0;i<16;i++) authkey2[i]^=0xff;
				md5.init();
				md5.update((unsigned char*)authkey2,sizeof(authkey2));
				md5.update((unsigned char*)sPasswd,strlen(sPasswd));
				md5.final((unsigned char*)cpw);
				soc.setPasswd((char*)cpw,16);
			}

			dat[0]=0x202;
			dat[1]=sizeof(HOSTINFO);
			info.stat=0;
			soc.send(dat,8);
			soc.send(&info,sizeof(HOSTINFO));
			fauth=1;
			return 1;
		}else{
			dat[0]=0x904;
			dat[1]=1;
			dat[2]=-1;
			soc.send(dat,12);
			return -1;
		}
	}
	if(dat[0]==RCMD_CHGMODE){ // [hύX
		soc.recv(&mode,4);
		return 1;
	}
	if(fauth==0){
		return -1;
	}
	if(dat[0]==RCMD_GETCURSOR){
		POINT m;
		GetCursorPos(&m);
		dat[0]=0x201;
		dat[1]=8;
		soc.send(dat,8);
		soc.send(&m,8);
		return 1;
	}else if(dat[0]==RCMD_SHELLEXEC){
		char cmd[1024];
		if(dat[1]>1000)
			return -1;
		soc.recv(cmd,dat[1]);
		PROCESS_INFORMATION Procinfo;
		STARTUPINFO StartInfo;
		ZeroMemory(&StartInfo,sizeof(STARTUPINFO));
		CreateProcess(NULL,cmd,NULL,NULL,FALSE,0,NULL,NULL,
			&StartInfo,&Procinfo);
		return 1;
	}
	if(mode<3){
		return -1;
	}
	if(dat[0]==RCMD_SETCURSOR){
		soc.recv(dat,8);
		SetCursorPos(dat[0],dat[1]);
	}else if(dat[0]==RCMD_MOUSE){
		int m[2];
		soc.recv(m,8);
		SetCursorPos(LOWORD(m[1]),HIWORD(m[1]));
		switch(m[0]){
		case WM_LBUTTONDOWN:
			mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
			break;
		case WM_LBUTTONUP:
			mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
			break;
		case WM_RBUTTONDOWN:
			mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,0,0);
			break;
		case WM_RBUTTONUP:
			mouse_event(MOUSEEVENTF_RIGHTUP,0,0,0,0);
			break;
		case WM_MBUTTONDOWN:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN,0,0,0,0);
			break;
		case WM_MBUTTONUP:
			mouse_event(MOUSEEVENTF_MIDDLEUP,0,0,0,0);
			break;
		}
	}else if(dat[0]==0x311){
		mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
		Sleep(40);
		mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
	}else if(dat[0]==0x312){
		mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,0,0);
		Sleep(40);
		mouse_event(MOUSEEVENTF_RIGHTUP,0,0,0,0);
	}else if(dat[0]==RCMD_KEYBD){
		soc.recv(dat,8);
		keybd_event(dat[1],0,dat[0]?KEYEVENTF_KEYUP:0,0);
	//	INPUT inputKey;
	//	inputKey.type = INPUT_KEYBOARD;
	//	inputKey.ki.wVk = dat[1];
	//	inputKey.ki.wScan = MapVirtualKey(dat[1], 0);
	//	inputKey.ki.dwFlags = (dat[0]<<1); // KEYEVENTF_KEYUP;
	//	inputKey.ki.dwExtraInfo = 0;
	//	inputKey.ki.time = 0;
	//	SendInput(1, &inputKey, sizeof(INPUT));
	}else{
		return -1;
	}
	return 1;

}

void CHost::InitDisp()
{
	HDC hDDC=CreateDC("DISPLAY",NULL,NULL,NULL);
	if(GetDeviceCaps(hDDC,BITSPIXEL)==16){
		bmpdepth=16;
	}else{
		bmpdepth=24;
	}
	int time=GetTickCount();
	int x,y;
	info.version=0x010;
	info.width=GetDeviceCaps(hDDC,HORZRES);
	info.height=GetDeviceCaps(hDDC,VERTRES);
	info.depth=bmpdepth;
	info.blocksize=BLOCKSIZE;
	BLOCK *tBlock;
	for(y=0;y<info.height/BLOCKSIZE;y++){
		for(x=0;x<info.width/BLOCKSIZE;x++){
			tBlock=mBlock;
			mBlock=new BLOCK;
			mBlock->x=x*BLOCKSIZE;
			mBlock->y=y*BLOCKSIZE;
			mBlock->next=tBlock;
		}
	}
	tmpBlock=new BLOCK;
	DeleteDC(hDDC);
}

void CHost::ResetDisp(){
	BLOCK *tBlock=mBlock;
	int time=GetTickCount();
	while(tBlock){
		tBlock->flag=1;
		tBlock->rate=500;
		tBlock->cnt=time+400+(rand()&255);
		memset(tBlock->bmp.pBit,0,tBlock->bmp.datsize);
		tBlock=tBlock->next;
	}
}

void CHost::EndDisp(){
	BLOCK *tBlock=mBlock;
	int time=GetTickCount();
	while(tBlock){
		mBlock=tBlock;
		delete tBlock;
		tBlock=mBlock->next;
	}
}

int CHost::ChkDisp(int m)
{
	HDC hDDC=CreateDC("DISPLAY",NULL,NULL,NULL);
	static BLOCK *tBlock=mBlock;
	BLOCK *sBlock=tBlock;
	int time=GetTickCount();
	int cnt=0;
	int err=0;
	int i=0;
	while(i<m){
		if(tBlock->cnt > time && tBlock->flag==0){
			if(time+2000 < tBlock->cnt){
				tBlock->cnt=time+tBlock->rate+(rand()&15);
			}
		}else{
			i++;
			BitBlt(tmpBlock->bmp.hDC,0,0,32,32,hDDC,tBlock->x,tBlock->y,SRCCOPY);
			if(memcmp(tBlock->bmp.pBit,tmpBlock->bmp.pBit,tBlock->bmp.datsize)){
				// XVĂ
				memcpy(tBlock->bmp.pBit,tmpBlock->bmp.pBit,tBlock->bmp.datsize);
				//tBlock->flag=1;
				if(tBlock->Send(&soc)){err=-1;break;}
				//tBlock->rate-=64;
				tBlock->rate>>=1;
				if(tBlock->rate<100)
					tBlock->rate=100;
				cnt++;
			}else{
				tBlock->rate+=tBlock->rate/100+1;
				if(tBlock->rate>1200)
					tBlock->rate=1200;
			}
			tBlock->cnt=time+tBlock->rate+(rand()&15);
		}
		tBlock=tBlock->next;
		if(!tBlock)
			tBlock=mBlock;
		if(tBlock==sBlock) break;
	}
	DeleteDC(hDDC);
	if(err) return err;
	return cnt;
}

//////////////////////////////////////////////////////////////////////////

BLOCK::BLOCK(){
	bmp.Create(BLOCKSIZE,BLOCKSIZE,bmpdepth); flag=0; next=NULL;
}

int BLOCK::Send(Connection *soc)
{
	if(bmpdepth==16){
		int size=rle16((unsigned short*)compbuf,(unsigned short*)bmp.pBit,bmp.datsize>>1);
		if(size+16<bmp.datsize){
			int dat[]={0x002,size+16,x,y,BLOCKSIZE,BLOCKSIZE};
			int stat=soc->send(dat, 24);
			if(stat!=24) return -1;
			if(soc->send(compbuf,size)!=size) return -1;
			flag=0;
			return 0;
		}
	}
	int dat[]={0x001,bmp.datsize+16,x,y,BLOCKSIZE,BLOCKSIZE};
	int stat=soc->send(dat, 24); 
	if(stat!=24) return -1;
	stat=soc->send(bmp.pBit,bmp.datsize);
	if(stat!=bmp.datsize) return -1;
	flag=0;
	return 0;
}

