/////////////////////////////////////////////////////////////////////////////
//				Bitmap class
//                                           Copyright(C) 2003 K-K

#include <windows.h>
#include "image.h"

CBitmap::~CBitmap()
{
	Delete();
}
CBitmap::CBitmap()
{
	mode=0;
}

int CBitmap::Create(int x,int y,int a)
{
	sx=x;
	sy=y;
	mode=a;
	HDC hdcWin;
	datsize=x*y*a >> 3;

	memset(&bmih,0,sizeof(bmih));
	bmih.biSize=sizeof(BITMAPINFOHEADER);
	bmih.biWidth=x;
	bmih.biHeight=y;
	bmih.biPlanes=1;
	bmih.biBitCount=mode;
	bmih.biSizeImage=datsize;

	hdcWin=NULL;//GetDC(hMainWnd); // EChEDC

	// DIB ƃEChEDC DIBSection 쐬
	hBmp=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,DIB_RGB_COLORS,(void**)&pBit,NULL,0);

	hDC=CreateCompatibleDC(hdcWin); // DC 쐬

	SelectObject(hDC,hBmp); // DC DIBSection I
	//ReleaseDC(hMainWnd,hdcWin);
	mode|=256;
	return 0;
}

void CBitmap::Delete(){
	if(mode&256){
		DeleteDC(hDC);
		DeleteObject(hBmp);
	}
	mode=0;
}

