
#include "sock.h"

#define DEFAULT_PORT 9876
#define BLOCKSIZE 32
#define RECVSIZE 65536

#define RCMD_SENDBMP	0x001
#define RCMD_SENDRLE	0x002
#define RCMD_CHGMODE	0x101
#define RCMD_GETCURSOR	0x201
#define RCMD_SETCURSOR	0x202
#define RCMD_MOUSE	0x301
#define RCMD_KEYBD	0x401
#define RCMD_SHELLEXEC	0x501


struct HOSTINFO{
	int version;
	int width;
	int height;
	int depth;
	int blocksize;
	int stat;
};


int rle16(unsigned short* outbuf,unsigned short* ibuf,int sz);
void unrle16(unsigned short* obuf,unsigned short* ibuf,int size);

class BLOCK{
public:
	int x,y;
	int flag;
	int cnt;
	int rate;
	CBitmap bmp;
	BLOCK *next;
	int Send(Connection *soc);
	BLOCK();
	~BLOCK(){ bmp.Delete(); }
};

class CHost{
	HWND hWnd;
	void MakeKey(unsigned char *dat,unsigned char *passwd,int key);
	int CmdRecv();
	void InitDisp();
	int ChkDisp(int m);
	void EndDisp();
	void ResetDisp();
	HOSTINFO info;
	int hostflag;
	int hostctl;
	int fauth;
	int authkey;
	char authkey2[16];
	int mode;
	BLOCK *mBlock;
	BLOCK *tmpBlock;
	static void ThreadStart(void *h);
	Connection soc;
//	DWORD soc;
public:
	short port;
	char sPasswd[64];
	int crypt;
	int Start(HWND win);
	int Stop();
	int Close();
	void Main();
	CHost();
	~CHost();
};
