
#ifndef _SOCK
#define _SOCK

class RC4 {
    int x, y;
	unsigned char m[256];
	int mode;
public:
	void init(void *key,int len);
	void crypt(void *dst, void *src, int len);
	RC4(){mode = 0;}
};

#ifndef INVALID_SOCKET
#define INVALID_SOCKET (~0)
#define SOCKET_ERROR  (-1)
#endif

class Connection {
	SOCKET soc;
	char passwd[128];
	RC4 rc4s;
	RC4 rc4r;
public:
	void setPasswd(char *pass) {rc4s.init(pass,0);rc4r.init(pass,0);;}
	void setPasswd(void *pass,int len) {rc4s.init(pass,len);rc4r.init(pass,len);}
	int connect(char *host,int port);
	int accept(int s,char *host,int *port);
	void close();
	bool isConnect() {return soc!=INVALID_SOCKET;}
	int check();
	int send(void *buf,int len);
	int recv(void *buf,int len);
	Connection();
	~Connection();
};

#endif
